
/********************************************
 **** Animation Class Library V1.0  1994 Yves Schmid & Alia Development
 ****
 **** AnimSupervisor.h
 ****
 **** Created:      06 June 1994
 **** Modified:     01 September 1994
 **** Version:      0
 **** Compatible:   C++, Mac System 7
 ****
 **** Description:   AnimSupervisor class is an abstract class which defines the base
 ****				of animation objects which can have subobjects under control.
 ****
 ****				 AnimSupervisor is a child clas of the CoreHead class.
 ****
 *******************/
 
#ifndef AnimSupervisor_H
#define AnimSupervisor_H


#include "CoreHead.h"

class AnimBase;
class AnimObject;
class AnimMask;
class AnimCollision;
class Anim;
class AnimGfx;
struct AnimFrameDef;

class AnimSupervisor: public CoreHead
{

	//***********************************************************
	//.............. P U B L I C   M E T H O D S.................
	
	public:

    AnimSupervisor(long nentry=0);                               	 // Object unlinked
    AnimSupervisor(AnimSupervisor *, long headentry,long nentry=0);  // Object under control of an
																	 // anim supervisor

	~AnimSupervisor(void);


	virtual AnimBase *getanimbase(void);	// Tries to find its AnimBase or returns NULL


	virtual Anim *createanim(void);					// Creates a simple Anim
	virtual Anim *createanim(AnimFrameDef *def);	// An array of AnimFrameDef
	virtual Anim *createanim(long resID);
	virtual Anim *createanim(AnimGfx *gfx);	

	virtual AnimMask *createanimmask(long resID);
	virtual AnimMask *createanimmask(AnimGfx *);

	virtual AnimCollision *createanimcollision(long resID);
	virtual AnimCollision *createanimcollision(AnimGfx *);



	// Returns the first/last animation object linked to this supervisor. If no objects returns NULL
	inline AnimObject *getanimobject_first(void) {return (AnimObject*) getentry(0)->getfirst();}
	inline AnimObject *getanimobject_last(void) {return (AnimObject*) getentry(0)->getlast();}


	unsigned long userdata;		// Use this variable like you want

};



#endif

